# system-dependent stuff

import os
import sys
import platform

def get_default_path():
    """Find the best data path (i.e. the path to the latest EP/SP)."""

    # this list needs to be in order: oldest to newest
    pack_names = [ "The Sims 2","The Sims 2 University","The Sims 2 Nightlife", \
        "The Sims 2 Open For Business","The Sims 2 Family Fun Stuff", \
        "The Sims 2 Glamour Life Stuff", "The Sims 2 Pets" ]

    lang2ccode = [ 0, 1, 3, 4, 5, 6, 9, 11, 7, 8, 35, 26, 12, 27, \
        15, 20, 13, 17, 18, 2, 16, 19, 10, 14, 28 ]

    # todo: Mac stuff

    path = None     # latest EP/SP path
    path2 = None    # base path
    cc = 1

    if platform.system() == "Windows":
        try:
            import _winreg      # doesn't always work (i.e. cygwin)
            w = True
        except ImportError:
            w = False

        if w:
            # Windows: path info should be in the registry
            k, key = None, None
            for i in range(len(pack_names)):    # get hkey for latest pack
                try:
                    s = "Software\\EA GAMES\\" + pack_names[i]
                    key = _winreg.OpenKey(_winreg.HKEY_LOCAL_MACHINE, s)
                    s2 = s
                except WindowsError:
                    key = None

                if key:
                    if k:
                        _winreg.CloseKey(k)     # close old hkey
                    k = key

            if k:
                try:
                    path, x = _winreg.QueryValueEx(k, "Install Dir")
                except WindowsError:
                    pass
                _winreg.CloseKey(k)             # close old hkey

                k = _winreg.OpenKey(_winreg.HKEY_LOCAL_MACHINE, "Software\\EA GAMES\\The Sims 2")
                if k:
                    try:
                        path2, x = _winreg.QueryValueEx(k, "Install Dir")
                    except WindowsError:
                        pass
                    _winreg.CloseKey(k)         # close old hkey

                k = _winreg.OpenKey(_winreg.HKEY_LOCAL_MACHINE, "Software\\EA GAMES\\The Sims 2\\1.0")
                if k:
                    try:
                        x2, x = _winreg.QueryValueEx(k, "Language")
                        cc = lang2ccode[x2]
                    except WindowsError:
                        pass

    return (path, path2, cc)
